package com.bonait.bnframework.modules.wmf.model;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;

import com.bonait.bnframework.R;

import java.util.ArrayList;
import java.util.List;

public class Mt_inf_model extends RecyclerView.Adapter<RecyclerView.ViewHolder> {

    private Context context;

    private Choice_mt_model mc;
    private  final int Type_Mtmodel = 0;

    private  final int Type_btn = 1;

    public  List<Mt_info> mtInfos;

    public List<Mt_recipe_model> mtRecipeModelList;


    public  Mt_inf_model(Context context, List<Mt_info> mt_infos) {
        this.mtInfos = mt_infos;
        this.context = context;
    }


        public class BtnViewHolder extends RecyclerView.ViewHolder{
            Button add_btn;
            public  BtnViewHolder(View view){
                super(view);
                add_btn = view.findViewById(R.id.add_list_btn);
            }
        }

        public class CardViewHolder extends RecyclerView.ViewHolder{
            Button write_button,delete_button,do_button,add_btn,down_btn;
            TextView text_1,text_2,text_3;

            public CardViewHolder(View itemView) {
                super(itemView);
                write_button = itemView.findViewById(R.id.recycle_view_write);
                delete_button = itemView.findViewById(R.id.recycle_view_delete);
                do_button = itemView.findViewById(R.id.recycle_view_do);
                text_1 = itemView.findViewById(R.id.name_text_1);
                text_2 = itemView.findViewById(R.id.src_text);
                text_3 = itemView.findViewById(R.id.text_count);
                add_btn = itemView.findViewById(R.id.ic_add_btn);
                down_btn = itemView.findViewById(R.id.ic_down_btn);
            }
        }





    @NonNull
    @Override
    public RecyclerView.ViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        if (viewType == Type_Mtmodel){
            View view = LayoutInflater.from(parent.getContext()).inflate(R.layout.mt_download,parent,false);
            return new CardViewHolder(view);
        }
        else {
            View view = LayoutInflater.from(parent.getContext()).inflate(R.layout.add_btn_list,parent,false);
            return new BtnViewHolder(view);
        }
    }

    @Override
    public void onBindViewHolder(@NonNull RecyclerView.ViewHolder holder, int position) {
        if (holder.getItemViewType() == Type_Mtmodel){
            CardViewHolder holder_card = (CardViewHolder) holder;
            Mt_info data = mtInfos.get(position);

            holder_card.do_button.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View view) {
                    data.setMt_src();
                    data.setName();
                    notifyDataSetChanged();
                }
            });
            holder_card.add_btn.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View view) {
                    data.setMt_count_add();
                    notifyDataSetChanged();
                }
            });
            holder_card.down_btn.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View view) {
                    data.setMt_count_down();
                    notifyDataSetChanged();
                }
            });
            holder_card.delete_button.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View view) {
                    mtInfos.remove(data);
                    notifyDataSetChanged();
                }
            });
            holder_card.write_button.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View view) {
                    Mt_info mt_info = new Mt_info();
                    Choice_mt_model.Builder builder = new Choice_mt_model.Builder(data, new View.OnClickListener() {
                        @Override
                        public void onClick(View view) {
                            switch (view.getId()){
                                case R.id.src_on_exit:

                                    mt_info = data;
                                    mtInfos.remove(data);
                                    mtInfos.add(position,mt_info);
                                    notifyDataSetChanged();
                                    mc.dismiss();
                                    break;
                                case R.id.src_on_sure:
                                    notifyDataSetChanged();
                                    mc.dismiss();
                                    break;
                            }

                        }
                    });
                    builder.Builder(context);
                    mc = builder.create();
                    mc.show();

                }
            });
            holder_card.text_1.setText(data.mt_name);
            holder_card.text_2.setText(data.mt_src);
            holder_card.text_3.setText(String.valueOf(data.mt_count));
        }
        else {
            BtnViewHolder holder_btn = (BtnViewHolder) holder;
            holder_btn.add_btn.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View view) {

                    Mt_info mt_info = new Mt_info();
                    mtRecipeModelList = new ArrayList<>();
                    for (int i = 0; i < 20; i++) {
                        Mt_recipe_model mmt = new Mt_recipe_model();
                        mmt.Mt_weight = i;
                        mmt.Mt_name = "物料" + i;
                        mtRecipeModelList.add(mmt);
                    }
                    mt_info.mtRecipeModels = mtRecipeModelList;
                    Choice_mt_model.Builder builder = new Choice_mt_model.Builder(mt_info, new View.OnClickListener() {
                        @Override
                        public void onClick(View view) {
                            switch (view.getId()){
                                case R.id.src_on_sure:
                                    mt_info.mt_src = "本地配方";
                                    mtInfos.add(mt_info);
                                    mc.dismiss();
                                    notifyDataSetChanged();
                                    break;
                                case R.id.src_on_exit:
                                    mc.dismiss();
                                    break;
                            }
                        }
                    });
                    builder.Builder(context);
                    mc = builder.create();
                    mc.show();
                }
            });
        }

    }

    @Override
    public int getItemCount() {
        if (mtInfos!=null){
            return mtInfos.size()+1;
        }
        else{
            return 1;
        }
    }

    @Override
    public int getItemViewType(int position){
        if (position<mtInfos.size()){
            return Type_Mtmodel;
        }else {
          return Type_btn;
        }
    }

}
