package com.bonait.bnframework.modules.wmf.model;

import android.content.Context;
import android.text.Editable;
import android.text.TextWatcher;
import android.util.AttributeSet;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.util.Log;
import android.widget.CheckBox;
import android.widget.CompoundButton;
import android.widget.LinearLayout;
import android.widget.RadioButton;
import android.widget.TextView;
import android.widget.EditText;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;

import com.bonait.bnframework.R;

import org.w3c.dom.Text;

import java.util.List;

public class Mt_recipe_set extends RecyclerView.Adapter<Mt_recipe_set.ViewHolder> {

    public List<Mt_recipe_model> mtRecipeModelList;

    /*子项控件绑定*/
    public Mt_recipe_set(List<Mt_recipe_model> recipeModels){
        this.mtRecipeModelList = recipeModels;
    }


    /*子项控件绑定*/
    public class ViewHolder extends RecyclerView.ViewHolder {
        CheckBox mt_check;
        TextView mt_name;
        EditText mt_weight;


        public ViewHolder(View itemView) {
            super(itemView);
            mt_check = itemView.findViewById(R.id.mt_check);
            mt_name = itemView.findViewById(R.id.mt_name);
            mt_weight = itemView.findViewById(R.id.mt_weight);
        }
    }



    /*根据类型创建子项*/
    @Override
    public ViewHolder onCreateViewHolder(ViewGroup parent, int viewType) {
            View view = LayoutInflater.from(parent.getContext()).inflate(R.layout.mt_userctrl, parent, false);
            ViewHolder holder = new ViewHolder(view);
            return holder;
    }


    @Override
    public void onBindViewHolder(ViewHolder holder, int position) {
        //mode
        Mt_recipe_model data = mtRecipeModelList.get(position);
        //绑定数据
        holder.mt_name.setText(data.Mt_name + "");
        holder.mt_weight.setText(String.valueOf(data.Mt_weight) + "");
        holder.mt_check.setChecked(data.Mt_c);
        holder.mt_check.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                data.Mt_c = holder.mt_check.isChecked();
            }
        });
        holder.mt_weight.addTextChangedListener(new TextWatcher() {
            @Override
            public void beforeTextChanged(CharSequence charSequence, int i, int i1, int i2) {

            }

            @Override
            public void onTextChanged(CharSequence charSequence, int i, int i1, int i2) {

            }

            @Override
            public void afterTextChanged(Editable editable) {
                if (holder.mt_weight.length() != 0) {
                    data.Mt_weight = Integer.parseInt(holder.mt_weight.getText().toString());
                } else
                    data.Mt_weight = 0;

            }
        });

    }

    @Override
    public int getItemCount() {
        if (mtRecipeModelList != null) {
            return mtRecipeModelList.size();
        }
        return 0;
    }

}
